package com.emsoft.common

import java.awt.Image
import java.awt.image.BufferedImage
import javax.imageio.ImageIO

class ImageHelper {

    static File scale(File original, String resultPath, int x, int y) {
        Assert.notNull(original, "original")
        Assert.notNull(resultPath, "resultPath")

        def img = ImageIO.read(original).getScaledInstance(x, y, Image.SCALE_AREA_AVERAGING)
        def bufImg = new BufferedImage(x, y, BufferedImage.TYPE_INT_RGB)
        def g2d = bufImg.createGraphics()
        g2d.drawImage(img, 0, 0, null)
        g2d.dispose()

        def file = new File(resultPath)
        ImageIO.write(bufImg, "jpg", file)
        return file
    }
}
