package com.emsoft.common


/**
 * @param < TValue >
 * @param < TResult >
 * @author Vladimir Zhukov
 */
class ResultInfo<TValue, TResult> implements Assignable<ResultInfo<TValue, TResult>> {

    TValue value
    TResult result
    String info

    ResultInfo() {
        this(null, null, StringHelper.EMPTY)
    }

    ResultInfo(TValue value, TResult result, String info) {
        this.value = value
        this.result = result
        this.info = info
    }

    void assign(ResultInfo<TValue, TResult> ri) {
        Assert.notNull(ri, "ri")
        value = ri.value
        result = ri.result
        info = ri.info
    }

    String toString() {
        //return "${this.class.simpleName} {value: $value, result: $result, info: '$info'}"
        return StringHelper.join(this.getClass().getSimpleName(), " value: ", value, ", result: ", result,
                ", info: ", info)
    }
}