package com.emsoft.events

import com.emsoft.common.Assert

/**
 * Base class for events.
 *
 * @author Vladimir Zhukov
 * @param < TEventType >
 * @param < TEventData >
 */
class EventArgs<TEventType, TEventData> {

    final TEventType eventType
    final TEventData eventData

    EventArgs(TEventType eventType, TEventData eventData) {
        Assert.notNull(eventType, "eventType")
        this.eventType = eventType
        this.eventData = eventData
    }
}
