package com.emsoft.exceptions

import com.emsoft.common.ResourceHelper
import com.emsoft.common.StringHelper

/**
 * @author Vladimir Zhukov
 */
class EmptyCollectionException extends RuntimeException {

    private static final long serialVersionUID = 74357396175639408L

    EmptyCollectionException() {
        this(StringHelper.EMPTY)
    }

    EmptyCollectionException(String collection) {
        this(collection, null)
    }

    EmptyCollectionException(String collection, Exception innerException) {
        super(String.format(ResourceHelper.getString(ExceptionHelper.ERROR_MESSAGES_RESOURCE,
                "EmptyCollectionExceptionMessage"), collection), innerException)
    }
}