package com.emsoft.exceptions

import com.emsoft.common.Helper

class ErrorCode {

    private static final List<ErrorCode> codes = new ArrayList<ErrorCode>()

    public static final ErrorCode OK = new ErrorCode(0)
    public static final ErrorCode INTERNAL_ERROR = new ErrorCode(500)

    int value

    protected ErrorCode(int value) {
        if (codes.any { c -> c.value == value })
            ExceptionHelper.throwValueAlreadyExists(value)

        this.value = value
        codes << this
    }

    private void setValue(int value) {
        this.value = value
    }

    static ErrorCode getErrorCode(int value, ErrorCode unknownErrorCode) {
        def code = codes.find { c -> c.value == value }
        return Helper.getValue(code, unknownErrorCode)
    }

    static ErrorCode getOrCreate(int value) {
        def code = codes.find { c -> c.value == value }
        if (!code)
            return new ErrorCode(value)
        return code
    }

    /*
    public static T GetErrorCode<T>(int value, T unknownErrorCode) where T : ErrorCode {
        var code = codes.FirstOrDefault(c => c.Value == value)
        if (code == null)
            return unknownErrorCode
        return (T)code
    }
    */
}
